import serial
import tkinter as tk
from collections import deque

# Configurar el puerto serial
puerto = serial.Serial('COM7', 9600)  # Reemplaza 'COMX' con el nombre correcto del puerto serial
buffer_size = 100
data_buffer = deque(maxlen=buffer_size)

# Función para actualizar los datos y la GUI
def update_data():
    lectura = puerto.readline().strip().decode('utf-8')
    try:
        valor = float(lectura)
        data_buffer.append(valor)
        label.config(text="Último valor: {:.2f}".format(valor))
        canvas.delete("all")
        for i, data in enumerate(data_buffer):
            x0 = i * 5
            y0 = 200 - data
            x1 = x0 + 5
            y1 = 200
            canvas.create_rectangle(x0, y0, x1, y1, fill="blue")
    except ValueError:
        pass
    root.after(20, update_data)  # Actualizar cada 20 milisegundos (50 Hz)

# Configurar la interfaz gráfica
root = tk.Tk()
root.title("Gráfico en tiempo real")
label = tk.Label(root, text="Último valor: ")
label.pack()
canvas = tk.Canvas(root, width=500, height=200, bg="white")
canvas.pack()

# Ejecutar la actualización de datos
root.after(20, update_data)
root.mainloop()

# Cerrar el puerto serial al finalizar
puerto.close()
